' DL9DWR				22.12.2017
' Funksteckdose mit PIC 16F84 (1k Speicher)                       
' Taktausgabe fr Fernbedienung Model:0175926R
' Setzen des Systemcode A0 - A4 im EEPROM des PIC
' Empfnger A
' Ein/Aus gesteuert ber Bewegungsmelder
' Sensoreingang: RB0, Funkausgang:RA0  
' mit serieller Dateneigabe
' Code nach dem Einschalten einlesen                           
         

         date 
         time
         
         
         define device 16f84, wdt_off, lvp_off, hs_osc
         xtal 4.00
         
         define serin = soft
                 
         eedata(0) 0,0,0,$f,0          ' setzen des EEPROM Systemcode A0 - A4 beim Programmieren
                                       ' wird ab SP 0 geladen ON = 0, OFF = f, default
         eedata(5) 0,$f,$f,$f          ' Empfnger A bis D, aktiver Empfnger ist "0" !
                                
         
         define a0    = $20            ' Systemcode A0 - A4           
         define a1    = $21
         define a2    = $22
         define a3    = $23
         define a4    = $24
         define a5    = $25            ' Empfnger A (- D)
         define a6    = $26
         define a7    = $27
         define a8    = $28
         define a9    = $29            
         define d0    = $2a            ' Einschalten
         define d1    = $2b            ' Ausschalten  
         define wdh   = $2c
         define in    = $2d
         define lfn   = $2e
         define adr   = $30 as byte 
         
                          
init:    tris ra=%00000000           'ra 7-0 output 
         tris rb=%00001111           'rb 7-4 output, rb 3-0 input
                   
         res rb,0                      'Eingabe auf "0" setzen 
         res ra,0
         set rb,1                      'Eingabe auf "1" setzen, serin
         set rb,2                      'Eingabe auf "1" setzen, Abfrage fr serin
         wait 1000                     'warten 1 sec.   
        
              
ser:     inp rb.2
         if rb,2 = 0 then gosub dat    

' Einlesen des Systemcodes A0 - A4 und aktive Steckdose (dann 0)          
rom:     read 0,a0
         read 1,a1
         read 2,a2
         read 3,a3
         read 4,a4
         read 5,a5                     ' Empfnger A
         read 6,a6                     ' Empfnger B
         read 7,a7                     ' Empfnger C
         read 8,a8                     ' Empfnger D
         let a9 = $f                   ' Float (E)
         
ein0:    inp rb.0
         if rb,0 = 0 then goto ein1        
         wait 500
         goto ein0


' aktiver Empfnger A ... D ein, festgelegt im EEPROM ab (5)- (8)        
ein1:    let d0 = $0                   ' ein 
         let d1 = $f                   ' aus
         gosub ausg
         
aus0:    inp rb.0
         if rb,0 = 1 then goto aus1       
         wait 500
         goto aus0                       

' aktiver Empfnger A ... D aus, festgelegt im EEPROM ab (5)- (8)          
aus1:    let d0 = $f                   ' ein
         let d1 = $0                   ' aus         
         gosub ausg
         res ra,0
         goto ein0
         
' Ausgabe 8 x Ausgabezyklus
ausg:    for wdh = 0 to 8
         res ra,0
         if a0 = 0 then gosub null else gosub float               
         if a1 = 0 then gosub null else gosub float 
         if a2 = 0 then gosub null else gosub float                          
         if a3 = 0 then gosub null else gosub float 
         if a4 = 0 then gosub null else gosub float 
         if a5 = 0 then gosub null else gosub float 
         if a6 = 0 then gosub null else gosub float 
         if a7 = 0 then gosub null else gosub float 
         if a8 = 0 then gosub null else gosub float 
         if a9 = 0 then gosub null else gosub float 
         if d0 = 0 then gosub null else gosub float 
         if d1 = 0 then gosub null else gosub float 
         gosub syn
         res ra,0
         next wdh
         return

null:    set ra,0
         delay 3
         res ra,0
         delay 10
         set ra,0
         delay 3
         res ra,0
         delay 10
         return         

float:   set ra,0
         delay 3
         res ra,0
         delay 10
         set ra,0
         delay 10
         res ra,0
         delay 3
         return

syn:     set ra,0
         delay 3
         res ra,0
         delay 70
         return
         
dat:     let lfn = 0                             ' Einlesen der Daten (PC) auf der ser.Schnittstelle                                       
datin:   serin ra,0,4800,in
         let adr(lfn)= in
         inc lfn
         if in = "*" then goto datend            ' Wenn "*", dann Datenende
         goto datin
datend:  let lfn = 0                             ' auf EEPROM umspeichern 
datwr:   write lfn,adr(lfn)
         inc lfn
         if in <> "*" then goto datwr            ' Wenn "*", dann Datenende
         return  
         
